<?php
/*
  Plugin Name: PayPal Digital Goods powered by Cleeng
  Plugin URI: http://www.cleeng.com/
  Version: 1.1.9
  Description: PayPal Digital Goods powered by Cleeng makes one-click content monetization extremely easy. This plugin is for everybody who wish to sell easily quality digital content: articles, photos, apps, videos or any other digital goods. Users can purchase using PayPal Digital Goods, and leverage Cleeng's frictionless user experience - pay with one click and access content instantly.
  Author: Cleeng
  Author URI: http://cleeng.com
  License: New BSD License (http://cleeng.com/license/new-bsd.txt)
 */

global $cleeng;

define( 'CLEENG_WP_PLUGIN_PATH',
        WP_PLUGIN_URL . '/' . str_replace( basename( __FILE__ ), "", plugin_basename( __FILE__ ) ) );

require_once dirname( __FILE__ ) . '/includes/CleengClient.php';

try {
    CleengClient::checkCompatibility();
    $cleeng_compatible_env = true;
    $cleeng_config = include dirname( __FILE__ ) . '/includes/config.php';
    $cleeng = new CleengClient( $cleeng_config );
} catch (CleengClientException $e) {    
    $cleeng_compatible_env = false;
}


load_plugin_textdomain( 'cleeng', false, dirname( plugin_basename( __FILE__ ) ) . '/languages/' );

/*
  CleengWP_Init includes necesarry plugin files in WP
 */
add_action( 'init', 'CleengWP_Init' );

function cleeng_display_incompatibility_warning() {
    echo '<div class="error cleeng_error"><p>';
    echo 'Your current environment is incompatible with Cleeng Plugin. Please make sure that you have PHP v5.1 or later, '
         . 'with JSON and CURL extensions enabled.';
    echo '</p></div>';
}

function CleengWP_Init() {
    global $cleeng_compatible_env;
    wp_enqueue_script( 'jquery' );
    if ( ! is_admin() ) {
        if ($cleeng_compatible_env) {
            require_once dirname( __FILE__ ) . '/includes/frontend.php';
        }
    } else {
        if ($cleeng_compatible_env) {
            require_once dirname( __FILE__ ) . '/includes/admin.php';
        } else {
            add_action( 'admin_notices', 'cleeng_display_incompatibility_warning' );
        }
    }
}
